import axios from 'axios'
import { getToken, removeToken, setToken } from './auth'
// create an axios instance
const service = axios.create({
  baseURL: 'http://jzmanager.aiyangniu.net', // url = base url + request url
  // withCredentials: true, // send cookies when cross-domain requests
  timeout: 5000 // request timeout
})

// request interceptor
service.interceptors.request.use(
  (config) => {
    // do something before request is sent
    var token = getToken()
    if (token === '' || token === null || token === 'undefined') {
      return config
    }else if(config.url === '/admin/login'){
      return config
    } 
    else {
      config.headers.token = token
      return config
    }
  },
  (error) => {
    // do something with request error
    console.log(error) // for debug
    return Promise.reject(error)
  }
)

// response interceptor
// service.interceptors.response.use(
//   /**
//    * If you want to get http information such as headers or status
//    * Please return  response => response
//    */

//   /**
//    * Determine the request status by custom code
//    * Here is just an example
//    * You can also judge the status by HTTP Status Code
//    */
//   (response) => {
//     const res = response.data;

//     // if the custom code is not 20000, it is judged as an error.
//     if (res.code !=== 20000) {
//       Message({
//         message: res.message || "Error",
//         type: "error",
//         duration: 5 * 1000,
//       });

//       // 50008: Illegal token; 50012: Other clients logged in; 50014: Token expired;
//       if (res.code === 50008 || res.code === 50012 || res.code === 50014) {
//         // to re-login
//         MessageBox.confirm(
//           "You have been logged out, you can cancel to stay on this page, or log in again",
//           "Confirm logout",
//           {
//             confirmButtonText: "Re-Login",
//             cancelButtonText: "Cancel",
//             type: "warning",
//           }
//         ).then(() => {
//           store.dispatch("user/resetToken").then(() => {
//             location.reload();
//           });
//         });
//       }
//       return Promise.reject(new Error(res.message || "Error"));
//     } else {
//       return res;
//     }
//   },
//   (error) => {
//     console.log("err" + error); // for debug
//     Message({
//       message: error.message,
//       type: "error",
//       duration: 5 * 1000,
//     });
//     return Promise.reject(error);
//   }
// );
service.interceptors.response.use(
  function(response) {
    // 对响应数据做点什么
    if (response.data.code === 401) {
      removeToken()
      popmessage({ type: 'error', str: '登陆已过期，请重新登录' })
      router.push('/login')
      setTimeout(() => {
        this.$router.go(0)
      }, 1000)
    }
    return response
  },
  function(error) {
    // 对响应错误做点什么

    return Promise.reject(error)
  }
)

export default service
